# -*- coding: utf-8 -*-
"""GA API."""
import traceback
import urllib
import xbmc

from lib import g
from lib.static import *
from lib.utils.httpRequest import HTTPRequest

class GaAPI(HTTPRequest):
    """GA API Class."""
    def _url(self):
        return u'https://www.google-analytics.com/collect'

    def request(self, method, url, data=None, params=None, verify=None):
        # Request for ga.
        if verify in (None, ):
            if 'https' in url:
                verify = False
            else:
                verify = True

        try:
            r = self._execute[method](url, data=data, params=params, verify=verify, timeout=5)
        except Exception:
            return {'code': 'except.err', 'msg': traceback.format_exc()}

        if r.ok:
            return {'code': 'ok'}
        else:
            return {'code': 'http.err', 'msg': g.ensureUTF8(r.text)}

    def hitEvent(self, category, action):
        params = {'t': 'event', 'v': 1, 'tid': GLOBAL_TID,
                  'cid': g().get('client_id'), 'ec': category, 'ea': action, 'ua': urllib.quote(xbmc.getUserAgent())}

        try:
            resp = self.request('GET', self._url(), params=params)
            if resp.get('code') not in ('ok', ):
                g.log_error(msg='{0}: {1}'.format(resp.get('code'), resp.get('msg')))
            return
        except:
            pass
