import re
import urllib
import os

import xbmc

class pathDecoder(object):
    """Decode for photo/video/music station thumbnail image real local path."""
    chars62 = {
            0:48,1:49,2:50,3:51,4:52,5:53,6:54,7:55,8:56,9:57,10:65,
            11:66,12:67,13:68,14:69,15:70,16:71,17:72,18:73,19:74,20:75,
            21:76,22:77,23:78,24:79,25:80,26:81,27:82,28:83,29:84,30:85,
            31:86,32:87,33:88,34:89,35:90,36:97,37:98,38:99,39:100,40:101,
            41:102,42:103,43:104,44:105,45:106,46:107,47:108,48:109,49:110,
            50:111,51:112,52:113,53:114,54:115,55:116,56:117,57:118,58:119,
            59:120,60:121,61:122
        }

    goldenPrimes = {
        1                  : 1,
        41                 : 59,
        2377               : 1677,
        147299             : 187507,
        9132313            : 5952585,
        566201239          : 643566407,
        35104476161        : 22071637057,
        2176477521929      : 294289236153,
        134941606358731    : 88879354792675,
        8366379594239857   : 7275288500431249,
        518715534842869223 : 280042546585394647
    }

    def __init__(self):
        pass

    def _unbase62(self, code):
        '''
            [PseudoCrypt]
                REF:
                    https://github.com/KevBurnsJr/pseudocrypt
                    http://pioneertools.blogspot.tw/2013/11/php-pseudocrypt-function.html
        '''
        ret = 0
        for idx, c in enumerate(code[::-1]):
            index = [k for k, v in self.chars62.iteritems() if v == ord(c)][0]
            ret += index * (62 ** idx)

        return ret

    def decode(self, objId, size = None):
        try:
            ceil = 62 ** len(objId)
            mmiprimes = self.goldenPrimes.values()
            mmiprimes.sort()
            mmi = mmiprimes[len(objId)]
            num = self._unbase62(objId)

            filename = (num * mmi) % ceil
            hexid = hex(filename).rstrip('L').lstrip('0x')

            if len(hexid) == 1:
                hexid = u'{0}0{1}'.format(2, hexid)
            elif len(hexid) == 2:
                hexid = u'{0}{1}'.format(2, hexid)
            else:
                hexid = u'{0}{1}'.format(2, hexid[-2:])

            if size is not None:
                #print u'{0}: {1}'.format(self.mediaType, u'{0}/{1}-{2}.jpg'.format(hexid, filename, size))
                return u'{0}/{1}-{2}.jpg'.format(hexid, filename, size)
            else:
                #print u'{0}: {1}'.format(self.mediaType, u'{0}/{1}.jpg'.format(hexid, filename))
                return u'{0}/{1}.jpg'.format(hexid, filename)
        except Exception as e:
            xbmc.log(u'HDPlayer Decode Error: ({0})'.format(str(e)), xbmc.LOGERROR)

        return None
